import java.lang.*;
import java.util.*;

class Customer {

	/**
	 *  The name of the customer .. last name, first name, MI
	 */
	private String name_;
	public String name() { return name_; }
	public void name( String aString ) { name_ = aString; }

	/**
	 *  Customer address all in one string ..
	 */
	private String address_;
	public String address() { return address_; }
	public void address( String aString ) { address_ = aString; }

	/**
	 *  The ID for this customer as a set of numeric characters
	 */
	private String id_;
	public String id() { return id_; }
	public void id( String aString ) { id_ = aString; }

	/**
	 *  The Basket for this customer
	 */
	private Basket basket_;
	public Basket basket() { return basket_; }
	public void basket( Basket aBasket ) { basket_ = aBasket; }

	/**
	 *  The Transactions for this customer
	 */
	private Vector customerTransactions_;
	public Vector customerTransactions() { return customerTransactions_; }
	public void customerTransactions( Vector theCTs ) { customerTransactions_ = theCTs; }

    Customer() {
        this.initialize();
    }

    Customer(String id, String name, String address) {
        this();
        this.id(id);
        this.name(name);
        this.address(address);
        this.basket(null);
    }

    private void initialize() {
    }

    public Vector tapesToCheckout() {
        return this.basket().tapes();
    }

    public int numberOfTapesToCheckout() {
        return this.basket().tapeCount();
    }

    public double normalPriceOfTapesToCheckout() {
        return this.basket().regularCost();
    }

    public Tape cheapestTapeToCheckout() {
        return this.basket().leastExpensive();
    }

    public Vector tapesToBeCheckedOutWithCategory(String theCategory) {

        Vector theTapes = new Vector();

        Enumeration theOC = this.tapesToCheckout().elements();
        while (theOC.hasMoreElements()) {
            Tape aTape = (Tape) theOC.nextElement();
            if (aTape.isOfCategory(theCategory)) {
                theTapes.addElement(aTape);
            }
        }
        return theTapes;
    }
}