import java.lang.*;
import java.util.*;

class PromoFive extends Promotion{

    PromoFive() {
        this.initialize();
    }

    private void initialize() {
        this.name("5 tapes for 5 days for $5.00 ");
        this.description("If the customer rents" +
              " 5 tapes at the same time the charge will" +
              " be $5.00 and the tapes will be due back" +
              " in 5 calendar days");
        this.id("a");
        this.active(true);
    }

    public double promoPrice(Customer aCustomer) {

        // see if this promo applies

        // first check if at least five tapes are being purchased
        // here we do not care if they are any category
        // but we could check ..


        if (aCustomer.numberOfTapesToCheckout() < 5){
        System.out.println("result from promoFive = " + Double.POSITIVE_INFINITY);
            return Double.POSITIVE_INFINITY;
        }

        // well we have satisfied the requirements so let us do it

        // ignore the first 5 tapes and then start charging regular price

        double result = 0.0;
        for (int i=0; i<aCustomer.numberOfTapesToCheckout(); i++) {
            if (i>4) {
                result += ((Tape) aCustomer.tapesToCheckout().elementAt(i)).rentalPrice();
            }
        }
        result += 5.00; // for the first 5

        System.out.println("result from promoFive = " + result);
        return result;
    }

    public boolean applicable(Customer aCustomer) {
        return true;
    }

}